////////////////////////////////////////////////////////////////////////////////
// Title:            Mini Assignment A
// Files:            Counter.java, CounterApp.java, RunAway.java
// Semester:         Spring 2008
//
// Author:           Timothy Bahls
// CS Login:         bahls
// Lecturer:         Timothy Bahls
////////////////////////////////////////////////////////////////////////////////

/**
 * This application class create and performs operations on Counter objects. It
 * is effectively a test class for the Counter class and it has failed the
 * tester if the output is not precisely the same as expected.txt
 * 
 * @author Tim Bahls
 */

public class CounterApp {
	public static void main(String[] args) {
		// Creates a new default Counter and print it's contents
		Counter counter1 = new Counter();
		System.out.println(counter1.getCount());

		// Creates a Counter starting at two and prints it's contents
		Counter counter2 = new Counter(2);
		System.out.println(counter2.getCount());

		// Prints the result of incrementing the first Counter three times
		counter1.increment();
		counter1.increment();
		counter1.increment();
		System.out.println(counter1.getCount());

		// Prints the results of printing the second counter twice
		counter2.increment();
		counter2.increment();
		System.out.println(counter2.getCount());

		// Creates a third Counter that starts with the same count as the first,
		// then prints it's contents
		Counter counter3 = counter1.createEquivalentCounter();
		System.out.println(counter3.getCount());

		// Resets the first Counter, increments it, and shows the result
		counter1.reset();
		counter1.increment();
		System.out.println(counter1.getCount());

		// Demonstrates that the new counter has not changed
		System.out.println(counter3.getCount());		
	}
}
